class Rbrain

  @threshold  = 30
  def self.init_neuron(id)
    #neuron[id, links, weights, thisstate, nextstate, fired?]
    neuron = [id, [], [], 0, 0, false]
    return neuron
  end

  def self.init_brain(n_count)
    neurons = []
    for i in 0..(n_count-1) do
      neurons << init_neuron(i)
    end
    return neurons
  end

  def self.make_connections(brain)
    num_conn = 0
    brain.each do |neuron|
      0..(rand(1..10)).times do  
        link = rand(1..brain.size-1)
        weight = rand(1..5)
        if not neuron[1].include?(link)
          neuron[1] << link
          neuron[2] << weight
	  num_conn += 1
        end
      end
    end
    return num_conn
  end

  def self.accum_rand_neuron(brain, wt)
    n = rand(brain.size)
    brain[n][4] += wt
    return n
  end

  def self.fire_neuron(neuron, brain)
    fired = false
    neuron[1].each do |n_link|
      brain[n_link][4] += neuron[2][n_link] if not neuron[2][n_link].nil?
      neuron[3] = 0
      neuron[4] = 0
      fired = true
    end
    return fired
  end

  def self.accum_all_neurons(brain, wt)
    neurons = brain
    neurons.each do |n|
      n[4] += wt
    end
  end

  def self.update_neuron(neuron, brain)
    fired = false
    if neuron[3] >= @threshold
      self.fire_neuron(neuron, brain)
      fired = true
    end
    neuron[3] += neuron[4]
    neuron[4] = 0
    neuron[5] = true if fired
    return fired
  end


  def self.print_fired_neurons(neurons)
    neurons.each do |n|
      puts "Fired #{n[0]}" if n[5]
    end
  end

  def self.set_threshold(value)
    @threshold = value
  end

  def self.get_threshold
    @threshold
  end

  def self.csv_init_brain(file)
    data ||= CSV.read(file)
    neuron_data = {}
    data.each do |n|
      k = n[0]
      v = n[1].to_i
      neuron_data[k] = v
    end

    brain = self.init_brain(neuron_data.size - 1)
    return neuron_data, brain
  end

  def self.csv_make_connections(brain, data, file)
    no_conn = 0
    conn_file_data ||= CSV.read(file)
    conn_file_data.each do |connection|
      from_id = connection[0]
      to_id   = connection[1]
      weight  = connection[2]
      brain[data[from_id].to_i][1] << data[to_id].to_i
      brain[data[from_id].to_i][2] << weight.to_i
      no_conn += 1
    end
    return no_conn
  end

end
